package de.fhdw.wtf.tooling.editor.proposals;

import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IDocument;

public class ClassProposal extends ColonOffsetProposal {
	private static ClassProposal instance;
	
	public static synchronized ClassProposal create() {
		if (instance == null) {
			instance = new ClassProposal();
		}
		return instance;
	}
	
	private ClassProposal() {
		super(new String[] { "class" });
	}
	
	@Override
	protected boolean isValid(final char c, final int offset, final IDocument doc) {
		return c == '[' && this.checkValidTransitively(offset, doc) || c == '}';
	}
	
	private boolean checkValidTransitively(final int offset, final IDocument doc) {
		int offsetCopy = offset;
		while (true) {
			char c;
			try {
				if (offsetCopy > 0) {
					c = doc.getChar(--offsetCopy);
					if (c == '{') {
						return false;
					}
					if (c == '[') {
						return true;
					}
				} else {
					return true;
				}
				
			} catch (final BadLocationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	@Override
	protected boolean isInvalid(final char c, final int offset, final IDocument doc) {
		return c == '{' || offset == 0;
	}
	
}
